"use strict";

exports.__esModule = true;
exports.setAddLanguageSelect = exports.setCurrentLang = exports.setTheme = exports.setLocals = exports.setOrder = exports.deleteNewField = exports.setConditionableFields = exports.setInitialData = exports.setFileUploadUrl = exports.setPredefinedEndpoint = exports.setPredefinedValues = exports.updateField = exports.deleteField = exports.createField = void 0;

var createField = function createField(data) {
  return function (dispatch) {
    dispatch({
      type: 'CREATE_FIELD',
      payload: {
        data: data
      }
    });
  };
};

exports.createField = createField;

var deleteField = function deleteField(id) {
  return function (dispatch) {
    dispatch({
      type: 'DELETE_FIELD',
      payload: {
        id: id
      }
    });
  };
};

exports.deleteField = deleteField;

var updateField = function updateField(data) {
  return function (dispatch) {
    dispatch({
      type: 'UPDATE_FIELD',
      payload: {
        data: data
      }
    });
  };
};

exports.updateField = updateField;

var setPredefinedValues = function setPredefinedValues(data) {
  return function (dispatch) {
    dispatch({
      type: 'SET_PREDEFINED',
      payload: {
        data: data
      }
    });
  };
};

exports.setPredefinedValues = setPredefinedValues;

var setPredefinedEndpoint = function setPredefinedEndpoint(data) {
  return function (dispatch) {
    dispatch({
      type: 'SET_PREDEFINED_ENDPOINT',
      payload: {
        data: data
      }
    });
  };
};

exports.setPredefinedEndpoint = setPredefinedEndpoint;

var setFileUploadUrl = function setFileUploadUrl(data) {
  return function (dispatch) {
    dispatch({
      type: 'SET_FILE_UPLOAD_URL',
      payload: {
        data: data
      }
    });
  };
};

exports.setFileUploadUrl = setFileUploadUrl;

var setInitialData = function setInitialData(data) {
  return function (dispatch) {
    dispatch({
      type: 'SET_INITIAL',
      payload: {
        data: data
      }
    });
  };
};

exports.setInitialData = setInitialData;

var setConditionableFields = function setConditionableFields(data) {
  return function (dispatch) {
    dispatch({
      type: 'SET_CONDITIONABLE_FIELDS',
      payload: {
        data: data
      }
    });
  };
};

exports.setConditionableFields = setConditionableFields;

var deleteNewField = function deleteNewField() {
  return function (dispatch) {
    dispatch({
      type: 'DELETE_NEW_FIELD',
      payload: {}
    });
  };
};

exports.deleteNewField = deleteNewField;

var setOrder = function setOrder(data) {
  return function (dispatch) {
    dispatch({
      type: 'SET_ORDER',
      payload: {
        data: data
      }
    });
  };
};

exports.setOrder = setOrder;

var setLocals = function setLocals(data) {
  return function (dispatch) {
    dispatch({
      type: 'SET_LOCALS',
      payload: {
        data: data
      }
    });
  };
};

exports.setLocals = setLocals;

var setTheme = function setTheme(data) {
  return function (dispatch) {
    dispatch({
      type: 'SET_THEME',
      payload: {
        data: data
      }
    });
  };
};

exports.setTheme = setTheme;

var setCurrentLang = function setCurrentLang(data) {
  return function (dispatch) {
    dispatch({
      type: 'SET_CURRENT_LANGUAGE',
      payload: {
        data: data
      }
    });
  };
};

exports.setCurrentLang = setCurrentLang;

var setAddLanguageSelect = function setAddLanguageSelect(data) {
  return function (dispatch) {
    dispatch({
      type: 'SET_ADD_LANGUAGE_SELECT',
      payload: {
        data: data
      }
    });
  };
};

exports.setAddLanguageSelect = setAddLanguageSelect;