"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _formActions = require("../../actions/formActions");

var _toolbarActions = require("../../actions/toolbarActions");

var _reactRedux = require("react-redux");

var _Input = _interopRequireDefault(require("./fields-wrappers/Input"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _FileCopy = _interopRequireDefault(require("@material-ui/icons/FileCopy"));

var _Edit = _interopRequireDefault(require("@material-ui/icons/Edit"));

var _core = require("@material-ui/core");

var _Select = _interopRequireDefault(require("./fields-wrappers/Select"));

var _ButtonGroup = _interopRequireDefault(require("@material-ui/core/ButtonGroup"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Checkbox = _interopRequireDefault(require("./fields-wrappers/Checkbox"));

var _Radio = _interopRequireDefault(require("./fields-wrappers/Radio"));

var _Date = _interopRequireDefault(require("./fields-wrappers/Date"));

var _Content = _interopRequireDefault(require("./fields-wrappers/Content"));

var _File = _interopRequireDefault(require("./fields-wrappers/File"));

var _Section = _interopRequireDefault(require("./fields-wrappers/Section"));

var _Signature = _interopRequireDefault(require("./fields-wrappers/Signature"));

var _Image = _interopRequireDefault(require("./fields-wrappers/Image"));

var _Video = _interopRequireDefault(require("./fields-wrappers/Video"));

var _helpers = require("../../utils/helpers");

var _useWindowSize2 = require("../hooks/useWindowSize");

var _lodash = _interopRequireDefault(require("lodash"));

var _jsxFileName = "/var/www/html/formbuilder/src/components/app/FieldWrapper.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function FieldWrapper(props) {
  var _this = this;

  var _React$useState = _react["default"].useState(false),
      options = _React$useState[0],
      setOptions = _React$useState[1];

  var _useWindowSize = (0, _useWindowSize2.useWindowSize)(),
      width = _useWindowSize.width;

  var enableEdit = function enableEdit(e) {
    props.enableFieldEdit(props.data.uuid);
  };

  var removeField = function removeField(e) {
    if (props.editId === props.data.uuid) {
      props.disableFieldEdit();
    }

    props.deleteField(props.data.uuid);
  };

  var cloneField = function cloneField(e) {
    var uuid = (0, _helpers.generateUUID)();
    var machineName = props.data.type + '-' + Math.round(Date.now() / 1000);

    var newData = _lodash["default"].cloneDeep(props.data);

    newData.uuid = uuid;
    newData.machineName = machineName;
    props.createField(newData);
  };

  var showOptions = function showOptions() {
    setOptions(true);
  };

  var hideOptions = function hideOptions() {
    setOptions(false);
  };

  var renderFields = function renderFields(predefined) {
    switch (props.data.type) {
      case 'text':
        return /*#__PURE__*/_react["default"].createElement(_Input["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 62,
            columnNumber: 17
          }
        });

      case 'checkbox':
        return /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 64,
            columnNumber: 17
          }
        });

      case 'radio':
        return /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 66,
            columnNumber: 17
          }
        });

      case 'select':
        return /*#__PURE__*/_react["default"].createElement(_Select["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 68,
            columnNumber: 17
          }
        });

      case 'content':
        return /*#__PURE__*/_react["default"].createElement(_Content["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 70,
            columnNumber: 17
          }
        });

      case 'date':
        return /*#__PURE__*/_react["default"].createElement(_Date["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 72,
            columnNumber: 17
          }
        });

      case 'file':
        return /*#__PURE__*/_react["default"].createElement(_File["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 74,
            columnNumber: 17
          }
        });

      case 'image':
        return /*#__PURE__*/_react["default"].createElement(_Image["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 76,
            columnNumber: 17
          }
        });

      case 'list':
        return /*#__PURE__*/_react["default"].createElement("h1", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 78,
            columnNumber: 17
          }
        }, "list");

      case 'quiz':
        return /*#__PURE__*/_react["default"].createElement("h1", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 80,
            columnNumber: 17
          }
        }, "quiz");

      case 'signature':
        return /*#__PURE__*/_react["default"].createElement(_Signature["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 82,
            columnNumber: 17
          }
        });

      case 'survey':
        return /*#__PURE__*/_react["default"].createElement("h1", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 84,
            columnNumber: 17
          }
        }, "survey");

      case 'video':
        return /*#__PURE__*/_react["default"].createElement(_Video["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 86,
            columnNumber: 17
          }
        });

      case 'section':
        return /*#__PURE__*/_react["default"].createElement(_Section["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 88,
            columnNumber: 17
          }
        });

      default:
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 91,
            columnNumber: 11
          }
        }, " Default ");
    }
  };

  var className = "wrapper ahfb-shadow-1 ahfb-bg-white ahfb-ml-3 ahfb-mr-3 ahfb-p-3 ahfb-relative";

  if (props.first) {
    className = className + ' first-field';
  }

  if (props.last) {
    className = className + ' last-field';
  }

  var predefined = {};
  props.predefined.map(function (item) {
    predefined[item.id] = item;
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 107,
      columnNumber: 5
    }
  }, props.data.name || props.data.type === 'content' || props.data.type === 'image' || props.data.type === 'video' ? /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    onMouseOver: showOptions,
    onMouseLeave: hideOptions,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 109,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "innerWrapper",
    style: {
      marginTop: width < 450 ? '30px' : ''
    },
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 110,
      columnNumber: 11
    }
  }, options ? /*#__PURE__*/_react["default"].createElement(_ButtonGroup["default"], {
    className: "options-menu ahfb-absolute ahfb-" + (props.theme.direction ? props.theme.direction : 'ltr') + "-1 ahfb-top-1 ahfb-float-right ahfb-zIndex",
    color: "primary",
    size: "small",
    "aria-label": "outlined primary button group",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 112,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "delete-icon",
    onClick: removeField,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 113,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react["default"].createElement(_Delete["default"], {
    fontSize: "small",
    color: "action",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 114,
      columnNumber: 19
    }
  })), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "edit-icon",
    onClick: enableEdit,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 116,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react["default"].createElement(_Edit["default"], {
    fontSize: "small",
    color: "action",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 117,
      columnNumber: 19
    }
  })), props.data.type !== 'section' ? /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "clone-icon",
    onClick: cloneField,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 120,
      columnNumber: 19
    }
  }, /*#__PURE__*/_react["default"].createElement(_core.Tooltip, {
    title: "Clone field",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 121,
      columnNumber: 19
    }
  }, /*#__PURE__*/_react["default"].createElement(_FileCopy["default"], {
    fontSize: "small",
    color: "action",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 122,
      columnNumber: 21
    }
  }))) : '') : "", renderFields(predefined))) : "");
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    editId: state.toolbar.editId,
    predefined: state.form.predefined,
    theme: state.form.theme,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    createField: function createField(id) {
      return dispatch((0, _formActions.createField)(id));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    },
    enableFieldEdit: function enableFieldEdit(id) {
      return dispatch((0, _toolbarActions.enableFieldEdit)(id));
    },
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(FieldWrapper);

exports["default"] = _default;
module.exports = exports.default;