"use strict";

exports.__esModule = true;
exports.fileUploadFieldsConfigs = void 0;

var _Globals = require("../../../../utils/Globals");

var fileUploadFieldsConfigs = {
  isRequired: {
    type: _Globals.FIELD_TYPES.CHECKBOX,
    configs: {
      label: {
        en: 'Required',
        ar: 'مطلوب'
      }
    }
  },
  name: {
    type: _Globals.FIELD_TYPES.TEXT,
    isTranslatable: true,
    error: true,
    configs: {
      label: {
        en: 'Field Name',
        ar: 'اسم الحقل'
      },
      required: true,
      autoFocus: true
    }
  },
  helpText: {
    type: _Globals.FIELD_TYPES.TEXT,
    isTranslatable: true,
    configs: {
      label: {
        en: 'Help Text',
        ar: 'نص المساعدة'
      }
    }
  },
  placeholder: {
    type: _Globals.FIELD_TYPES.TEXT,
    isTranslatable: true,
    configs: {
      label: {
        en: 'Placeholder',
        ar: 'نائب'
      }
    }
  }
};
exports.fileUploadFieldsConfigs = fileUploadFieldsConfigs;