"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _App = _interopRequireDefault(require("./components/app/App"));

var _reactRedux = require("react-redux");

var _styles = require("@material-ui/core/styles");

var _colors = require("@material-ui/core/colors");

var _redux = require("redux");

var _rootReducer = _interopRequireDefault(require("./reducers/rootReducer"));

var _reduxThunk = _interopRequireDefault(require("redux-thunk"));

var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));

require("./styles/index.scss");

var _jsxFileName = "/var/www/html/formbuilder/src/index.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var theme = (0, _styles.createMuiTheme)({
  palette: {
    primary: {
      main: _colors.blue[700]
    }
  }
});

var FormBuilder = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(FormBuilder, _React$Component);

  function FormBuilder(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "initializeSubmit", function () {
      _this.child.current.submitForm();
    });

    _this.child = _react["default"].createRef();
    _this.state = {
      loading: true
    };
    return _this;
  }

  var _proto = FormBuilder.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    setTimeout(function () {
      _this2.setState({
        loading: false
      });
    }, 1000);
  };

  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState, nextContext) {
    return this.state.loading;
  };

  _proto.render = function render() {
    var _this3 = this;

    if (this.state.loading) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "ahfb-width-full ahfb-text-center ahfb-pt-5 ahfb-pb-5",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 48,
          columnNumber: 9
        }
      }, /*#__PURE__*/_react["default"].createElement(_CircularProgress["default"], {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 49,
          columnNumber: 11
        }
      }));
    }

    return /*#__PURE__*/_react["default"].createElement(_reactRedux.Provider, {
      store: (0, _redux.createStore)(_rootReducer["default"], (0, _redux.applyMiddleware)(_reduxThunk["default"])),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 54,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-width-full",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 58,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement(_App["default"], {
      locals: this.props.locals,
      theme: this.props.theme,
      initializeSubmit: function initializeSubmit(click) {
        return _this3.initializeSubmit = click;
      },
      currentLang: this.props.currentLang,
      onSubmit: this.props.onSubmit,
      formData: this.props.data,
      predefinedEndpoint: this.props.predefinedEndpoint,
      fileUploadUrl: this.props.fileUploadUrl,
      conditionableFields: this.props.conditionableFields,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 59,
        columnNumber: 11
      }
    })));
  };

  return FormBuilder;
}(_react["default"].Component);

FormBuilder.defaultProps = {
  data: {
    "5e455c88-e060-4f16-b2f9-1aaffbe8a87c": {
      "name": "First Name",
      "machineName": "first_name",
      "order": 1,
      "uuid": "5e455c88-e060-4f16-b2f9-1aaffbe8a87c",
      "type": "text",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "isRichText": false,
        "maxLength": null,
        "placeholder": null,
        "helpText": null,
        "subType": "text",
        "regex": null,
        "visibility": true
      },
      "locals": {
        "ar": {
          "name_ar": "الإسم الأوّل"
        }
      }
    },
    "473cc6d2-38fe-4525-8495-4e13a630f8af": {
      "name": "Last Name",
      "machineName": "last_name",
      "order": 2,
      "uuid": "473cc6d2-38fe-4525-8495-4e13a630f8af",
      "type": "text",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "isRichText": false,
        "maxLength": null,
        "placeholder": null,
        "helpText": null,
        "subType": "text",
        "regex": null,
        "visibility": true
      },
      "locals": {
        "ar": {
          "name_ar": "إسم العائلة"
        }
      }
    },
    "7533c815-6827-490c-800b-4d61c9936fb8": {
      "name": "Offer Letter",
      "machineName": "file-1651145479",
      "order": 4,
      "uuid": "7533c815-6827-490c-800b-4d61c9936fb8",
      "type": "file",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "placeholder": "Drag and drop files here",
        "helpText": null,
        "subType": "file",
        "visibility": true,
        "isMultiple": false,
        "supportedFiles": []
      },
      "locals": {
        "ar": {
          "name_ar": "العرض الوظيفي"
        }
      }
    },
    "7461c609-5bb0-46cf-9ecd-ef6579458187": {
      "name": "Signature Date",
      "machineName": "date-1651145512",
      "order": 5,
      "uuid": "7461c609-5bb0-46cf-9ecd-ef6579458187",
      "type": "date",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "helpText": null,
        "subType": "date",
        "visibility": true,
        "shouldDateValidate": false,
        "dateValidations": {
          "pastUnit": "days",
          "pastMax": 0,
          "pastMin": 0,
          "futureUnit": "days",
          "futureMax": 0,
          "futureMin": 0
        }
      },
      "locals": {
        "ar": {
          "name_ar": "تاريخ التوقيع"
        }
      }
    },
    "7621fefc-e85a-4c50-842d-35a3fd996151": {
      "name": "Signature",
      "machineName": "signature-1651145538",
      "order": 6,
      "uuid": "7621fefc-e85a-4c50-842d-35a3fd996151",
      "type": "signature",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "helpText": null,
        "subType": "signature",
        "visibility": true
      },
      "locals": {
        "ar": {
          "name_ar": "التوقيع"
        }
      }
    },
    "05bcc604-eaa0-4f3f-9e7d-b312633ae8ee": {
      "name": "Contract Upload",
      "machineName": "file-1651145972",
      "order": 7,
      "uuid": "05bcc604-eaa0-4f3f-9e7d-b312633ae8ee",
      "type": "file",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "placeholder": "Drag and drop files here",
        "helpText": null,
        "subType": "file",
        "visibility": true,
        "isMultiple": false,
        "supportedFiles": []
      },
      "locals": {
        "ar": {
          "name_ar": "تحميل العقد"
        }
      }
    },
    "0e6e4f91-cf03-4766-8687-c364cb7feaaa": {
      "name": "Was the New Hire Profile created on HRIS (SAP)?",
      "machineName": "radio-1651145889",
      "order": 8,
      "uuid": "0e6e4f91-cf03-4766-8687-c364cb7feaaa",
      "type": "radio",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "helpText": null,
        "subType": "radio",
        "visibility": true,
        "optionReferenceId": 72,
        "enableOther": false
      },
      "locals": {
        "ar": {
          "name_ar": "هل تم إنشاء ملف تعريف الموظف الجديد على نظام معلومات الموارد البشرية (SAP)؟"
        }
      }
    },
    "c4b71341-694d-4238-a8d9-af4fe93e5a07": {
      "name": "Assigned Laptop Serial Number",
      "machineName": "text-1651146130",
      "order": 11,
      "uuid": "c4b71341-694d-4238-a8d9-af4fe93e5a07",
      "type": "text",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": [{
            "field": "radio-1651146064",
            "operator": "is",
            "value": 1797
          }]
        },
        "isConditionalEnabled": true,
        "isRequired": true,
        "isRichText": false,
        "maxLength": null,
        "placeholder": null,
        "helpText": null,
        "subType": "text",
        "regex": null,
        "visibility": true
      },
      "locals": {
        "ar": {
          "name_ar": "الرقم التسلسلي المخصص للكمبيوتر المحمول"
        }
      }
    },
    "41e3e48a-94ce-454a-bb69-8715e8a603ed": {
      "name": "Assigned Monitor Serial Number",
      "machineName": "text-1651146210",
      "order": 12,
      "uuid": "41e3e48a-94ce-454a-bb69-8715e8a603ed",
      "type": "text",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": [{
            "field": "radio-1651146064",
            "operator": "is",
            "value": 1798
          }]
        },
        "isConditionalEnabled": true,
        "isRequired": true,
        "isRichText": false,
        "maxLength": null,
        "placeholder": null,
        "helpText": null,
        "subType": "text",
        "regex": null,
        "visibility": true
      },
      "locals": {
        "ar": {
          "name_ar": "الرقم التسلسلي المخصص للشاشة"
        }
      }
    },
    "92f5ea5f-c156-4918-ab48-2997f925e539": {
      "name": "Assigned Mouse Serial Number",
      "machineName": "text-1651146250",
      "order": 13,
      "uuid": "92f5ea5f-c156-4918-ab48-2997f925e539",
      "type": "text",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": [{
            "field": "radio-1651146064",
            "operator": "is",
            "value": 1799
          }]
        },
        "isConditionalEnabled": true,
        "isRequired": true,
        "isRichText": false,
        "maxLength": null,
        "placeholder": null,
        "helpText": null,
        "subType": "text",
        "regex": null,
        "visibility": true
      },
      "locals": {
        "ar": {
          "name_ar": "الرقم التسلسلي المخصص للماوس"
        }
      }
    },
    "a057a76d-65d3-47ef-8a9f-3eee14388b0f": {
      "name": "Assigned Headphones Serial Number",
      "machineName": "text-1651146283",
      "order": 14,
      "uuid": "a057a76d-65d3-47ef-8a9f-3eee14388b0f",
      "type": "text",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": [{
            "field": "radio-1651146064",
            "operator": "is",
            "value": 1800
          }]
        },
        "isConditionalEnabled": true,
        "isRequired": true,
        "isRichText": false,
        "maxLength": null,
        "placeholder": null,
        "helpText": null,
        "subType": "text",
        "regex": null,
        "visibility": true
      },
      "locals": {
        "ar": {
          "name_ar": "الرقم التسلسلي المخصص لسماعات الرأس"
        }
      }
    },
    "fd1bf416-e2e1-4489-95f0-ee4c84efb106": {
      "name": "Has an office been allocated?",
      "machineName": "radio-1651146391",
      "order": 15,
      "uuid": "fd1bf416-e2e1-4489-95f0-ee4c84efb106",
      "type": "radio",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "helpText": null,
        "subType": "radio",
        "visibility": true,
        "optionReferenceId": 74,
        "enableOther": false
      },
      "locals": {
        "ar": {
          "name_ar": "هل تم تخصيص مكتب؟"
        }
      }
    },
    "f7d308b5-b6fb-4172-aae8-fefd91b1d5c3": {
      "name": "Office Allocation",
      "machineName": "text-1651146434",
      "order": 16,
      "uuid": "f7d308b5-b6fb-4172-aae8-fefd91b1d5c3",
      "type": "text",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": [{
            "field": "radio-1651146391",
            "operator": "is",
            "value": 1801
          }]
        },
        "isConditionalEnabled": true,
        "isRequired": true,
        "isRichText": false,
        "maxLength": null,
        "placeholder": null,
        "helpText": null,
        "subType": "text",
        "regex": null,
        "visibility": true
      },
      "locals": {
        "ar": {
          "name_ar": "المكتب المخصّص"
        }
      }
    },
    "c07cc059-2fe4-4e09-a59c-06a82b999a0b": {
      "name": "Is an Airline Ticket Needed?",
      "machineName": "radio-1651146500",
      "order": 17,
      "uuid": "c07cc059-2fe4-4e09-a59c-06a82b999a0b",
      "type": "radio",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "helpText": null,
        "subType": "radio",
        "visibility": true,
        "optionReferenceId": 75,
        "enableOther": false
      },
      "locals": {
        "ar": {
          "name_ar": "هل هناك حاجة إلى تذكرة طيران؟"
        }
      }
    },
    "8fe7e29f-b25a-461a-b965-5966498a2b5b": {
      "name": "Upload Airline Ticket",
      "machineName": "file-1651146548",
      "order": 18,
      "uuid": "8fe7e29f-b25a-461a-b965-5966498a2b5b",
      "type": "file",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "placeholder": "Drag and drop files here",
        "helpText": null,
        "subType": "file",
        "visibility": true,
        "isMultiple": false,
        "supportedFiles": []
      },
      "locals": {
        "ar": {
          "name_ar": "تحميل تذكرة طيران"
        }
      }
    },
    "2049f615-05e1-4187-8bff-f0949c7cb2e3": {
      "name": "Is ground transportation needed?",
      "machineName": "radio-1651146592",
      "order": 19,
      "uuid": "2049f615-05e1-4187-8bff-f0949c7cb2e3",
      "type": "radio",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "helpText": null,
        "subType": "radio",
        "visibility": true,
        "optionReferenceId": 75,
        "enableOther": false
      },
      "locals": {
        "ar": {
          "name_ar": "هل النقل البري مطلوب؟"
        }
      }
    },
    "5a4f7cf3-dc1a-4a5d-bab8-9ad5f65eefa1": {
      "name": "Joining Date",
      "machineName": "joining_date",
      "order": 3,
      "uuid": "5a4f7cf3-dc1a-4a5d-bab8-9ad5f65eefa1",
      "type": "date",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "helpText": null,
        "subType": "date",
        "visibility": true,
        "shouldDateValidate": false,
        "dateValidations": {
          "pastUnit": "days",
          "pastMax": 0,
          "pastMin": 0,
          "futureUnit": "days",
          "futureMax": 0,
          "futureMin": 0
        }
      },
      "locals": {
        "ar": {
          "name_ar": "تاريخ الانضمام"
        }
      }
    },
    "1bc0ceaf-e7df-4748-a9cd-6c7332fb4fcc": {
      "name": "Assigned Hardware",
      "machineName": "checkbox-1652085089",
      "order": 9,
      "uuid": "1bc0ceaf-e7df-4748-a9cd-6c7332fb4fcc",
      "type": "checkbox",
      "parentId": 0,
      "config": {
        "conditionalLogic": {
          "display": "show",
          "logic": "all",
          "conditions": []
        },
        "isConditionalEnabled": false,
        "isRequired": true,
        "helpText": null,
        "subType": "checkbox",
        "visibility": true,
        "optionReferenceId": 77,
        "enableOther": false
      },
      "locals": []
    }
  },
  // data: {},
  theme: {
    direction: 'ltr'
  },
  currentLang: 'en',
  locals: [{
    key: 'ar',
    name: 'Arabic'
  }, {
    key: 'ru',
    name: 'Russian'
  }]
};
var _default = FormBuilder;
exports["default"] = _default;
module.exports = exports.default;