"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Checkbox = _interopRequireDefault(require("../checkboxs/Checkbox"));

var _SearchableSelect = _interopRequireDefault(require("../selects/SearchableSelect"));

var _TextInput = _interopRequireDefault(require("../inputs/TextInput"));

var _core = require("@material-ui/core");

var _jsxFileName = "/var/www/html/formbuilder/src/utils/date-validation/index.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var dateValidationLabel = {
  en: 'Set Date Validation',
  ar: 'تحديد تاريخ التحقق من الصحة'
};
var setPastDateLabel = {
  en: 'Set Past Date',
  ar: 'تعيين التاريخ الماضي'
};
var setFutureDateLabel = {
  en: 'Set Future Date',
  ar: 'تحديد موعد في المستقبل'
};
var unitLabel = {
  en: 'Unit',
  ar: 'وحدة'
};
var minLabel = {
  en: 'Min',
  ar: 'دقيقة'
};
var maxLabel = {
  en: 'Max',
  ar: 'الأعلى'
};
var dayLabel = {
  en: 'Days',
  ar: 'أيام'
};
var monthLabel = {
  en: 'Months',
  ar: 'الشهور'
};
var yearLabel = {
  en: 'Years',
  ar: 'سنوات'
};

function DateValidation(props) {
  var _props$errors, _props$errors$pastLim, _props$errors2, _props$errors2$pastLi, _props$errors3, _props$errors3$future, _props$errors4, _props$errors4$future;

  var durationOptions = [{
    label: dayLabel[props.currentLang],
    value: 'days'
  }, {
    label: monthLabel[props.currentLang],
    value: 'months'
  }, {
    label: yearLabel[props.currentLang],
    value: 'years'
  }];
  return /*#__PURE__*/_react["default"].createElement("div", {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 47,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
    checked: props.shouldDateValidate,
    handleChange: function handleChange(val) {
      return props.handleChange(val, 'shouldDateValidate');
    },
    label: dateValidationLabel[props.currentLang],
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 48,
      columnNumber: 7
    }
  }), props.shouldDateValidate ? /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 50,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    className: "mb-2",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 51,
      columnNumber: 11
    }
  }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
    checked: props.shouldPastDateValidate,
    handleChange: function handleChange(val) {
      return props.handleChange(val, 'shouldPastDateValidate');
    },
    label: setPastDateLabel[props.currentLang],
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 52,
      columnNumber: 13
    }
  })), props.shouldPastDateValidate && /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true,
    spacing: 3,
    className: "mt-4",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 55,
      columnNumber: 13
    }
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 56,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
    label: unitLabel[props.currentLang],
    options: durationOptions,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'pastUnit');
    },
    value: props.pastUnit,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 57,
      columnNumber: 17
    }
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    container: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 59,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pr-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 60,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    type: "number",
    label: minLabel[props.currentLang],
    value: props.pastMin,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'pastMin');
    },
    error: (_props$errors = props.errors) == null ? void 0 : (_props$errors$pastLim = _props$errors.pastLimitValidation) == null ? void 0 : _props$errors$pastLim.min,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 61,
      columnNumber: 15
    }
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pl-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 63,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    type: "number",
    label: maxLabel[props.currentLang],
    value: props.pastMax,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'pastMax');
    },
    error: (_props$errors2 = props.errors) == null ? void 0 : (_props$errors2$pastLi = _props$errors2.pastLimitValidation) == null ? void 0 : _props$errors2$pastLi.max,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 64,
      columnNumber: 15
    }
  })))), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    className: "mb-2",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 69,
      columnNumber: 11
    }
  }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
    checked: props.shouldFutureDateValidate,
    handleChange: function handleChange(val) {
      return props.handleChange(val, 'shouldFutureDateValidate');
    },
    label: setFutureDateLabel[props.currentLang],
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 70,
      columnNumber: 13
    }
  })), props.shouldFutureDateValidate && /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true,
    spacing: 3,
    className: "mt-4",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 73,
      columnNumber: 13
    }
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 74,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
    label: unitLabel[props.currentLang],
    options: durationOptions,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'futureUnit');
    },
    value: props.futureUnit,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 75,
      columnNumber: 15
    }
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    container: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 77,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pr-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 78,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    type: "number",
    label: minLabel[props.currentLang],
    value: props.futureMin,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'futureMin');
    },
    error: (_props$errors3 = props.errors) == null ? void 0 : (_props$errors3$future = _props$errors3.futureLimitValidation) == null ? void 0 : _props$errors3$future.min,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 79,
      columnNumber: 19
    }
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pl-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 81,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    type: "number",
    label: maxLabel[props.currentLang],
    value: props.futureMax,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'futureMax');
    },
    error: (_props$errors4 = props.errors) == null ? void 0 : (_props$errors4$future = _props$errors4.futureLimitValidation) == null ? void 0 : _props$errors4$future.max,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 82,
      columnNumber: 19
    }
  }))))) : "");
}

var _default = DateValidation;
exports["default"] = _default;
module.exports = exports.default;